class Element
  colum_structures = () ->
    raise
  
  list_opt_for_panel = () ->
    {}
  
  show_opt_for_panel = () ->
    {}
  
  json_opt_for_panel = () ->
    {}
  
  path_name = (with_engine = false) ->
    self.to_s.tableize
  
  
  
  has_picture? = () ->
    false
  
  has_part? = () ->
    false
  
  parts = () ->
    @parts ||= []
  
  has_helper? = (column_name) ->
    self.class.colum_structures[column_name] and self.class.colum_structures[column_name][:helper]
  
  element_name = () ->
    self.class.to_s.underscore
  
  extend_column = () ->
    nil
  
  extend_element_name = () ->
    self.extend_column ? self.attributes[extend_column] : self.element_name
  
  find_configurations hash, key = () ->
     if hash[key].is_a? String
       self.find_configurations hash, hash[key]
     else
       return hash[key]
  
  new_index = () ->
    @new_index
  
  new_index= v = () ->
    @new_index = v
  
  new_panel = () ->
    @new_panel
  
  new_panel= v = () ->
    @new_panel = v
  
  get_panel = () ->
    self.panel || @new_panel
  
  tag_id = (c = nil) ->
    'panel' + self.tag_panel_id + self.tag_element_type + self.tag_element_id + c.to_s
  
  field_tag_id = (f) ->
    self.tag_id + f.to_s
  
  tag_panel_id = () ->
    self.get_panel.new_record? ? '0' : self.get_panel.id.to_s
  
  tag_element_id = () ->
    self.new_record? ? '0' : self.id.to_s
  
  tag_element_type = () ->
    raise
  
  tag_new_index = () ->
    self.new_index.to_s
  
  path_name = (with_engine = false) ->
    self.class.path_name(with_engine)
  
  form_template = (with_engine = false) ->
    self.path_name(with_engine) + '/form'
  
  scenario_template = (with_engine = false) ->
    self.path_name(with_engine) + '/scenario'
  
  element_face_template = (with_engine = false) ->
    self.path_name(with_engine) + '/element_face'
  
  form_helper_template(colum_name) = () ->
    self.class.colum_structures[colum_name][:helper]
  
  tag_attributes = (column = nil, opt = {}) ->
    {
      :id => self.field_tag_id(column), :panel_id => self.tag_panel_id, 
      :element_id => self.tag_element_id, :element_type => self.tag_element_type
    }.merge(opt)
  
  field_tag_attributes = (column, no_attr, opt = {}) ->
    self.tag_attributes(column).merge(
      {:column => column, :new_index => self.tag_new_index, :no_attr => no_attr}
    ).merge(opt)
  
  #render element by body
  any_tag_attributes = (name = nil, opt = {}) ->
    r = self.tag_attributes(name)
    _.extend(r, 
      {:new_index => self.tag_new_index}
    ) if self.new_index
    r.merge(opt)
  
  select_tag_attributes = (selected, column, no_attr) ->
    [
      :last, :first, 
      {:html => {:selected => selected}}, 
      self.field_tag_attributes(column, no_attr)
    ]
  
  tag_attr = (column = nil, opt = {}) ->
    self.tag_attributes(column, opt).to_attr
  
  field_tag_attr = (column, no_attr, opt = {}) ->
    self.field_tag_attributes(column, no_attr, opt).to_attr
  
  any_tag_attr = (name = nil, opt = {}) ->
    self.any_tag_attributes(name, opt).to_attr

  @pettanr_current_panel_id = 0
  
  @new_element_index = {}
  @new_element_index[PettanrEditor.pettanr_current_panel_id] = 0
  
  @current_panel = () ->
    $('#panel' + PettanrEditor.pettanr_current_panel_id.toString())
  
  @set_tree_value = (keys, last_attr, value) ->
    key = keys.shift()
    if keys.length <= 0
      last_attr[key] = value
    else
      last_attr[key] = last_attr[key] || {}
      PettanrEditor.set_tree_value(keys, last_attr[key], value)

  @repeat_texts = ['repeat', 'repeat-x', 'repeat-y', 'no-repeat']
  
  @is_editting = () ->
    trace = '#panel' + PettanrEditor.pettanr_current_panel_id.toString() + 'wrapper'
    if $(trace) and $(trace).attr('editable')
      return true
    else
      return false
  @is_editable = (p) ->
    if p.parent().attr('editable')
      return true
    else
      return false
  @is_var = (o) ->
    if parseInt(o.attr('no_attr')) > 0
      return false
    else
      if o.attr('column') 
        if o.attr('column') == '_destroy' and o.val().length < 1
          return false
        else
          return true
      else
        return false
  @is_panel = (o) ->
    if PettanrEditor.is_element(o)
      return false
    else
      return true
  @is_element = (o) ->
    if o.attr('element_type')
      return true
    else
      return false
  @is_element_part = (o) ->
    if o.attr('element_part_type')
      return true
    else
      return false
  @element_is = (element_type, o) ->
    if PettanrEditor.is_element(o) and o.attr('element_type') == element_type
      return true
    else
      return false
  @element_types  = {'panel_picture': 'panel_pictures', 'speech_balloon': 'speech_balloons', 'ground_picture': 'ground_pictures', 'ground_color': 'ground_colors'}
  @element_type_to_table = (element_type) ->
    PettanrEditor.element_types[element_type]
  @text_align_texts = ['left', 'left', 'right', 'center']

  @make_tree = (attr, o) ->
    if PettanrEditor.is_var(o)
      tree = 'panels-' + o.attr('panel_id') + '-'
      if PettanrEditor.is_element(o)
        tree = tree + PettanrEditor.element_type_to_table(o.attr('element_type')) + '_attributes-' + o.attr('element_id') + '-'
        if PettanrEditor.is_element_part(o)
          tree = tree + o.attr('element_part_type') + '_attributes-'
      tree = tree + o.attr('column')
      keys = tree.split('-')
      PettanrEditor.set_tree_value(keys, attr, o.val())
  
  @panel_tag_id = (element) ->
    '#panel' + element.attr('panel_id')
  
  @element_tag_id = (element) ->
    '#panel' + element.attr('panel_id') + element.attr('element_type') + element.attr('element_id')
  
  @element_part_tag_id = (element_part) ->
    '#panel' + element_part.attr('panel_id') + element_part.attr('element_type') + element_part.attr('element_id') + element_part.attr('element_part_type') + element_part.attr('element_part_id')
  
  @refresh_attribute = (field) ->
    attr = {}
    $('input').map ->
      PettanrEditor.make_tree(attr, $(@))
    $('textarea').map  ->
      PettanrEditor.make_tree(attr, $(@))
    $('select').map ->
      PettanrEditor.make_tree(attr, $(@))
    field.val(JSON.stringify(attr['panels'][PettanrEditor.pettanr_current_panel_id.toString() ]))
  
@PettanrEditor = PettanrEditor
